<script setup>
    import JetButton from '@/Jetstream/Button.vue';
    import AppLayout from '@/Layouts/AppLayout.vue';
    import InfiniteLoading from "v3-infinite-loading";
    import "v3-infinite-loading/lib/style.css"; //required if you're not going to override default slots
    import { Link } from '@inertiajs/inertia-vue3';
    import JetTextarea from '@/Jetstream/Textarea.vue';
    import { useForm } from '@inertiajs/inertia-vue3';
    import JetInputError from '@/Jetstream/InputError.vue';
    import JetFormSection from '@/Jetstream/FormSection.vue';
    import JetDangerButton from '@/Jetstream/DangerButton.vue';

    const moment = require('moment')
    const form = useForm({
        _method: 'PUT',
        content: '',
    });
    const storePost = () => {
        form.post(route('post.store'), {
            errorBag: 'storePost',
            preserveScroll: true,
            onSuccess: (response) => {
                form.reset();
                location.reload();
            },
            onError: () => {

            },
        });
    };

</script>

<template>

        <div class="py-12">


            <div class="max-w-7xl mx-auto sm:px-6 lg:px-8"  >
                <JetFormSection @submitted="storePost" :fullForm="true" class="mb-2">
                    <template #form>
                        <div class="col-span-6 sm:col-span-4 mb-2">
                            <JetTextarea
                                    id="content"
                                    placeholder="What's on your mind?"
                                    v-model="form.content"
                                    type="text"
                                    class="mt-1 block w-full"
                            />
                            <JetInputError :message="form.errors.content" class="mt-2" />

                            <JetButton class="mt-4 ml-2" :disabled="form.processing">
                                Save
                            </JetButton>
                        </div>
                    </template>
                </JetFormSection>



                <div  class=" mb-3 flex flex-col items-center bg-white rounded-lg border shadow-md md:flex-row  hover:bg-gray-100 dark:border-gray-700 dark:bg-gray-800 dark:hover:bg-gray-700" v-for="post in posts" :key="post.id">
                    <img class="ml-2 h-8 w-8 rounded-full object-cover" v-if="post.user.profile_photo_url !== null" :src="post.user.profile_photo_url" >
                    <div class="flex flex-col justify-between p-4 leading-normal">
                        <p class="mb-3 font-normal text-gray-700 dark:text-gray-400" v-html="post.content"></p>
                        <p class="mb-3 font-italic text-gray-700 dark:text-gray-400 " v-if="post.posted_datetime !== null" v-html="moment(post.posted_datetime,'YYYY-MM-DD h:mm:ss').fromNow()"></p>
                        <p class="mb-3 font-normal text-gray-700 dark:text-gray-400">
                            <JetDangerButton @click="deletePost(post.id)" v-if="post.user_id === $page.props.user.id">
                                Delete
                            </JetDangerButton>


                        </p>

                    </div>
                </div>


                    <InfiniteLoading :posts="posts" @infinite="load">
                        <template #complete>
                            <span></span>
                        </template>
                    </InfiniteLoading>


            </div>
        </div>

</template>

<script>
    export default {
        name: "NewsFeed",
        data(){
            return {
                posts:[],
                page:1,
            }
        },
        methods:{
            async load($state) {

                let here = this;

                try {
                    const response = await fetch(route('post.index',{page:here.page}));
                    const json = await response.json();

                    here.posts.push(...json.data);
                    $state.loaded();



                    if (_.isEmpty(json.next_page_url))
                    {
                        $state.complete();
                    }
                    else {
                        here.page++;
                    }

                } catch (error) {
                    $state.error();
                }
            },
            deletePost(postId)
            {
                axios.delete(route('post.delete',{post:postId}));
                this.$inertia.get(route('dashboard'));            }


        }
    }
</script>

<style scoped>
    .result {
        display: flex;
        flex-direction: column;
        gap: 5px;
        font-weight: 300;
        width: 400px;
        padding: 10px;
        text-align: center;
        margin: 0 auto 10px auto;
        background: #eceef0;
        border-radius: 10px;
    }
</style>